FLTK 1.3.2

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Static Protected Member Functions
Fl_Image Class Reference

Fl_Image is the base class used for caching and drawing all kinds of images in FLTK. More...

`#include <Fl_Image.H>`

Inheritance diagram for Fl_Image:

List of all members.

## Public Member Functions
virtual void | color_average (Fl_Color c, float i)
| The color_average() method averages the colors in the image with the FLTK color value c.
virtual Fl_Image * | copy (int W, int H)
| The copy() method creates a copy of the specified image.
Fl_Image * | copy ()
| The copy() method creates a copy of the specified image.
int | count () const
| The count() method returns the number of data values associated with the image.
int | d () const
| Returns the current image depth.
const char *const * | data () const
| Returns a pointer to the current image data array.
virtual void | desaturate ()
| The desaturate() method converts an image to grayscale.
virtual void | draw (int X, int Y, int W, int H, int cx=0, int cy=0)
| Draws the image with a bounding box.
void | draw (int X, int Y)
| Draws the image.
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth.
int | h () const
| Returns the current image height in pixels.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out.
virtual void | label (Fl_Widget *w)
| The label() methods are an obsolete way to set the image attribute of a widget or menu item.
virtual void | label (Fl_Menu_Item *m)
| The label() methods are an obsolete way to set the image attribute of a widget or menu item.
int | ld () const
| Returns the current line data size in bytes.
virtual void | uncache ()
| If the image has been cached for display, delete the cache data.
int | w () const
| Returns the current image width in pixels.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.
## Protected Member Functions
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current array pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it.
void | h (int H)
| Sets the current image height in pixels.
void | ld (int LD)
| Sets the current line data size in bytes.
void | w (int W)
| Sets the current image width in pixels.
## Static Protected Member Functions
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Detailed Description

Fl_Image is the base class used for caching and drawing all kinds of images in FLTK.

This class keeps track of common image data such as the pixels, colormap, width, height, and depth. Virtual methods are used to provide type-specific image handling.

Since the Fl_Image class does not support image drawing by itself, calling the draw() method results in a box with an X in it being drawn instead.

## Constructor & Destructor Documentation

Fl_Image::Fl_Image | ( | int | W,
|  | int | H,
|  | int | D
| ) |  | `[inline]`

The constructor creates an empty image with the specified width, height, and depth.

The width and height are in pixels. The depth is 0 for bitmaps, 1 for pixmap (colormap) images, and 1 to 4 for color images.

## Member Function Documentation

void Fl_Image::color_average | ( | Fl_Color | c,
|  | float | i
| ) |  | `[virtual]`

The color_average() method averages the colors in the image with the FLTK color value c.

The i argument specifies the amount of the original image to combine with the color, so a value of 1.0 results in no color blend, and a value of 0.0 results in a constant image of the specified color. The original image data is not altered by this method.

Reimplemented in Fl_RGB_Image, Fl_Pixmap, Fl_Shared_Image, and Fl_Tiled_Image.

Fl_Image * Fl_Image::copy | ( | int | W,
|  | int | H
| ) |  | `[virtual]`

The copy() method creates a copy of the specified image.

If the width and height are provided, the image is resized to the specified size. The image should be deleted (or in the case of Fl_Shared_Image, released) when you are done with it.

Reimplemented in Fl_RGB_Image, Fl_Pixmap, Fl_Shared_Image, Fl_Bitmap, and Fl_Tiled_Image.

Fl_Image* Fl_Image::copy | ( |  | ) | `[inline]`

The copy() method creates a copy of the specified image.

If the width and height are provided, the image is resized to the specified size. The image should be deleted (or in the case of Fl_Shared_Image, released) when you are done with it.

Reimplemented in Fl_RGB_Image, Fl_Pixmap, Fl_Shared_Image, Fl_Bitmap, and Fl_Tiled_Image.

int Fl_Image::count | ( |  | ) | const`[inline]`

The count() method returns the number of data values associated with the image.

The value will be 0 for images with no associated data, 1 for bitmap and color images, and greater than 2 for pixmap images.

int Fl_Image::d | ( |  | ) | const`[inline]`

Returns the current image depth.

The return value will be 0 for bitmaps, 1 for pixmaps, and 1 to 4 for color images.

const char* const* Fl_Image::data | ( |  | ) | const`[inline]`

Returns a pointer to the current image data array.

Use the count() method to find the size of the data array.

void Fl_Image::desaturate | ( |  | ) | `[virtual]`

The desaturate() method converts an image to grayscale.

If the image contains an alpha channel (depth = 4), the alpha channel is preserved. This method does not alter the original image data.

Reimplemented in Fl_RGB_Image, Fl_Pixmap, Fl_Shared_Image, and Fl_Tiled_Image.

void Fl_Image::draw | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | cx = `0`,
|  | int | cy = `0`
| ) |  | `[virtual]`

Draws the image with a bounding box.

This form specifies a bounding box for the image, with the origin (upper-lefthand corner) of the image offset by the cx and cy arguments.

Reimplemented in Fl_RGB_Image, Fl_Pixmap, Fl_Shared_Image, Fl_Bitmap, and Fl_Tiled_Image.

void Fl_Image::draw | ( | int | X,
|  | int | Y
| ) |  | `[inline]`

Draws the image.

This form specifies the upper-lefthand corner of the image.

Reimplemented in Fl_RGB_Image, Fl_Pixmap, Fl_Shared_Image, Fl_Bitmap, and Fl_Tiled_Image.

void Fl_Image::draw_empty | ( | int | X,
|  | int | Y
| ) |  | `[protected]`

The protected method draw_empty() draws a box with an X in it.

It can be used to draw any image that lacks image data.

void Fl_Image::inactive | ( |  | ) | `[inline]`

The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out.

This method does not alter the original image data.

void Fl_Image::label | ( | Fl_Widget * | widget | ) | `[virtual]`

The label() methods are an obsolete way to set the image attribute of a widget or menu item.

Use the image() or deimage() methods of the Fl_Widget and Fl_Menu_Item classes instead.

Reimplemented in Fl_RGB_Image, Fl_Pixmap, and Fl_Bitmap.

void Fl_Image::label | ( | Fl_Menu_Item * | m | ) | `[virtual]`

The label() methods are an obsolete way to set the image attribute of a widget or menu item.

Use the image() or deimage() methods of the Fl_Widget and Fl_Menu_Item classes instead.

Reimplemented in Fl_RGB_Image, Fl_Pixmap, and Fl_Bitmap.

int Fl_Image::ld | ( |  | ) | const`[inline]`

Returns the current line data size in bytes.

Line data is extra data that is included after each line of color image data and is normally not present.

void Fl_Image::uncache | ( |  | ) | `[virtual]`

If the image has been cached for display, delete the cache data.

This allows you to change the data used for the image and then redraw it without recreating an image object.

Reimplemented in Fl_RGB_Image, Fl_Pixmap, Fl_Shared_Image, and Fl_Bitmap.

The documentation for this class was generated from the following files:

- Fl_Image.H
- Fl_Image.cxx